Package org.apache.tapestry5.services.pageload

## Enum ReferenceType

- java.lang.Object
- - java.lang.Enum<ReferenceType>
  - - org.apache.tapestry5.services.pageload.ReferenceType

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<ReferenceType>`

      public enum ReferenceType
      extends java.lang.Enum<ReferenceType>

  Defines the types of reference the page cache can use.
  Since:
    5.8.3
  See Also:
    `PageCachingReferenceTypeService`

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `SOFT` | Use a soft reference (SoftReference) to cached page instances.
    `STRONG` | Use a strong (normal) reference to cached page instances.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `PageCachingReferenceTypeService` | `forPages​(java.lang.String... canonicalPageNames)` | Utility method that returns PageCachingReferenceTypeService matching page names in a case-insensitive way.
    `static ReferenceType` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static ReferenceType[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### SOFT

          public static final ReferenceType SOFT

      Use a soft reference (SoftReference) to cached page instances.

    - #### STRONG

          public static final ReferenceType STRONG

      Use a strong (normal) reference to cached page instances.

  - ### Method Detail

    - #### values

          public static ReferenceType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ReferenceType c : ReferenceType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ReferenceType valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### forPages

          public PageCachingReferenceTypeService forPages​(java.lang.String... canonicalPageNames)

      Utility method that returns PageCachingReferenceTypeService matching page names in a case-insensitive way.
      Returns:
        a PageCachingReferenceTypeService instance.